"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var metadata_1 = require("../../metadata");
var validation_1 = require("../ruleset/validation");
var Ajv = require('ajv');
var Controller = /** @class */ (function () {
    // ########################################
    function Controller(consoleArguments, currentRootPath) {
        this.consoleArguments = consoleArguments;
        this.currentRootPath = currentRootPath;
        // ########################################
        this.metadata = metadata_1.METADATA;
    }
    // ########################################
    Controller.prototype.process = function () {
        var command = null;
        // TODO create --help command
        for (var i = 0; i < this.consoleArguments.length; i++) {
            if (this.metadata.commands[this.consoleArguments[i]]) {
                command = this.consoleArguments[i];
                break;
            }
        }
        if (!command) {
            throw new Error('Command not found.');
        }
        var commandSettings = this.metadata['commands'][command];
        var commandHandler = new commandSettings['handler'](this.consoleArguments, commandSettings, this.currentRootPath, new validation_1.Validation(this.currentRootPath, this.metadata['allowed_protocol_versions'], new Ajv()));
        commandHandler.process();
    };
    return Controller;
}());
exports.Controller = Controller;
